"use client";

import { toast } from "sonner";
import { useMutation, useQuery, useQueryClient } from "@tanstack/react-query";

import {
    Form,
    FormControl,
    FormField,
    FormItem,
    FormLabel,
    FormMessage,
} from "@/components/ui/form";

import React, { useEffect, useState } from "react";
import { ErrorResponseProps } from "@/lib/features/admin/account/type";
import { useForm } from "react-hook-form";
import { zodResolver } from "@hookform/resolvers/zod";
import { z } from "zod";
import { Input } from "@/components/ui/input";
import { Button } from "@/components/ui/button";
import { LoaderCircle } from "lucide-react";
import { geOneClub, updateClub } from "@/lib/features/admin/club/service";
import { ClubFormValidation } from "@/lib/features/admin/club/schema";
import { ResponseProps } from "@/lib/features/login/type";
import { ErrorMessage } from "@/components/ui/error-message";
import Loading from "../../components/loading";

interface Props {
    onCloseModal: () => void;
    refreshNow: () => void;
    dataId: number;
}

export const UpdateClubFormDialog = ({ dataId, onCloseModal, refreshNow }: Props) => {

    // states
    const [name, setName] = useState('');
    const [desc, setDesc] = useState('');

    const [image, setImage] = useState('');
    const [status, setStatus] = useState('1');

    const [sending, setSending] = useState(false);


    // club details
    const {
        data,
        isLoading,
        error
    } = useQuery({
        queryKey: ["view-club-details-for-update"],
        queryFn: () => geOneClub(dataId),
    });


    // Update states
    useEffect(() => {
        if (data?.data?.details) {
            setName(data?.data?.details?.name)
            setDesc(data?.data?.details?.description);

            setImage(data?.data?.details?.image)

        }

    }, [data]);



    const queryClient = useQueryClient();

    const mutation = useMutation({
        mutationFn: updateClub,
        onSuccess: (data) => {
            queryClient.invalidateQueries({ queryKey: ["updateClubInfo"] });

            const response = data as unknown as ResponseProps;

            if (response?.data?.message) {
                toast.success(response?.data?.message);

                // close modal
                onCloseModal();

                //refresh clubs
                refreshNow();

            } else {
                toast.error(response?.data?.error);
            }

            //window.location.reload();
        },
        onError: (error) => {

            const newError = error as unknown as ErrorResponseProps;
            toast.error(newError?.response?.data?.message);

            return false;
            //window.location.reload();
        },
    });

    function onSubmit() {

        if (name === null || name === '') {
            toast.error("Name is required");
            return false;
        }

        else if (desc === null || desc === '') {
            toast.error("Description is required");
            return false;
        }

        else if (image === null || image === '') {
            toast.error("Image url is required");
            return false;
        }

        else if (status === null || status === '') {
            toast.error("Status is required");
            return false;
        }

        else {

            setSending(true);

            const body = {
                name: name,
                description: desc,

                image: image,
                status: status,
                clubId: dataId
            }

            // console.log(JSON.stringify(body));
            // return false;

            mutation.mutate(body);
        }
    }



    // Form setup
    const form = useForm<z.infer<typeof ClubFormValidation>>({
        resolver: zodResolver(ClubFormValidation),
        defaultValues: {
        },
    });


    if (isLoading) {
        return <Loading />;
    }


    //////////////////////error handling

    //error
    if (error) {
        return <ErrorMessage error={error} fallback="Dashboard error" />
    }



    return (
        <div>
            <div className="text-sm font-medium text-center text-neutral-600 pb-4">
                Update club
            </div>

            <Form {...form}>
                <form className="space-y-6">
                    <div className="grid gap-2">

                        <div className="grid grid-cols-1 gap-2">

                            <FormField
                                control={form.control}
                                name="name"
                                render={({ }) => (
                                    <FormItem>
                                        <FormLabel>Name</FormLabel>
                                        <FormControl>
                                            <Input type="text" value={name} onChange={(e) => setName(e.target.value)} />
                                        </FormControl>
                                        <FormMessage />
                                    </FormItem>
                                )}
                            />

                            <FormField
                                control={form.control}
                                name="description"
                                render={({ }) => (
                                    <FormItem>
                                        <FormLabel>Description</FormLabel>
                                        <FormControl>
                                            <Input type="text" value={desc} onChange={(e) => setDesc(e.target.value)} />
                                        </FormControl>
                                        <FormMessage />
                                    </FormItem>
                                )}
                            />

                            <FormField
                                control={form.control}
                                name="image"
                                render={({ }) => (
                                    <FormItem>
                                        <FormLabel>Image</FormLabel>
                                        <FormControl>
                                            <Input type="text" value={image} onChange={(e) => setImage(e.target.value)} />
                                        </FormControl>
                                        <FormMessage />
                                    </FormItem>
                                )}
                            />


                            <FormField
                                control={form.control}
                                name="image"
                                render={({ }) => (
                                    <FormItem>
                                        <FormLabel>Status</FormLabel>
                                        <select
                                            className="w-full border border-gray-300 rounded p-2"
                                            value={status}
                                            onChange={(e) => setStatus(e.target.value)}
                                        >
                                            <option value=""></option>

                                            <option key="1" value="1">Active</option>
                                            <option key="0" value="0" className="text-red-500">Remove</option>
                                        </select>
                                        <FormMessage />
                                    </FormItem>
                                )}
                            />


                        </div>

                        <Button className="confirm-button mt-4" type="button" onClick={onSubmit}  >
                            {sending ?
                                <LoaderCircle className="animate-spin" />
                                : "UPDATE"
                            }
                        </Button>
                    </div>
                </form>
            </Form>
        </div>
    );

}